package com.parnes.telldus.server;

import java.io.IOException;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.parnes.telldus.client.TelldusService;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class TelldusServiceImpl extends RemoteServiceServlet implements
		TelldusService {
	
	final static boolean WINDOWS = false;
	
	final static String PATH_WINDOWS = "c:\\work\\tdtool\\"; 
	final static String COMMANDS_WINDOWS[] = { "off-0.bat", "on-0.bat", "off-1.bat", "on-1.bat", "off-2.bat", "on-2.bat" };
	final static String PATH_MAC = "/Users/parnes/work/telldus/tdtool/";
	final static String COMMANDS_MAC[] = { "off0", "on0", "off1", "on1", "off2", "on2" }; 
	static String path = PATH_MAC; 
	static String commands[] = COMMANDS_MAC; 
	
	static {
		if(WINDOWS) {
			path = PATH_WINDOWS;
			commands = COMMANDS_WINDOWS;
		} else {
			path = PATH_MAC; 
			commands = COMMANDS_MAC;
		}
	}
	
	public Boolean power(int unit, boolean on) {
		
		boolean result = false;
		
		int index = unit * 2 + (on?1:0);
		
		String command = path; 
		command += commands[index];
			
		try {
			Process p = Runtime.getRuntime().exec(command);
			try {
				p.waitFor();
			} catch (InterruptedException ignored) {
			}
			result = true;
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return new Boolean(result);
	}
	
}
